/* A useful tool */
/* Copyright (c)1999 ADM (andrew@mcdonald.org.uk) */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <time.h>
#include "stegfs.h"

char *pw = "Password1";

int main(int argc, char *args[]) {
  char type;
  char data[1024];
  unsigned long int bnum, numb, i, j, k;
  struct stegfs_inode *sfsi;
  unsigned int *data32;
  struct ext2_dir_entry_2 *dent;
  char *key;
  struct stegfs_fs fs;
  struct stegfs_fs *fssys = &fs;
  char skeyin[16], skey[16];
  unsigned int *xkey;

  if(argc < 4 || argc > 5) {
    printf("Usage: readdata fs type startblock numblocks\n");
    printf("type = u - unknown, i - stegfs inode, d - directory block,\n");
    printf("n - indirection block\n");
    return 1;
  }

  if(strlen(args[2]) != 1 || (args[2][0]!='u' && args[2][0]!='i' &&
			      args[2][0]!='n' && args[2][0]!='d')) {
    printf("bad type\n");
    return 1;
  }

  type = args[2][0];
  bnum = strtoul(args[3],NULL,0);
  numb = argc==5 ? strtoul(args[4],NULL,0) : 1;

  /*  fs = fopen(args[1],"r"); */
  open_fs(fssys, args[1], "/mnt/hda1btab", "rc6");

  if(!get_ext2_super(fssys)) {
    return 3;
  }

  fseek(fssys->btabfile,
	fssys->sb.s_blocks_count*sizeof(struct stegfs_btable), SEEK_SET);
  fread(&skeyin, 16, 1, fssys->btabfile);
  decrypt_skey(fssys, "Password1", skeyin, skey);
  xkey = (unsigned int *)skey;
  printf("key: %08x %08x %08x %08x\n",
	   xkey[0], xkey[1], xkey[2], xkey[3]);

  fseek(fssys->fsfile, bnum*1024, SEEK_SET);

  for(i=0; i<numb; i++) {
    key = make_key(skey, bnum);
    fread(data, 1024, 1, fssys->fsfile);
    decrypt_cbc(fssys, key, data, 1024);

    if(type == 'u') {
      for(j=0; j<1024; j++)
	printf("%c", data[j]);
    }
    else if(type == 'i') {
      sfsi = (struct stegfs_inode *)data;

      printf("mode = %o\n", sfsi->i_mode);
      printf("uid = %u\n", sfsi->i_uid);
      printf("size = %u\n", sfsi->i_size);
      printf("atime = %s", ctime((time_t *)&(sfsi->i_atime)));
      printf("ctime = %s", ctime((time_t *)&(sfsi->i_ctime)));
      printf("mtime = %s", ctime((time_t *)&(sfsi->i_mtime)));
      printf("dtime = %s", ctime((time_t *)&(sfsi->i_dtime)));
      printf("gid = %u\n", sfsi->i_gid);
      printf("links = %u\n", sfsi->i_links_count);
      printf("blocks = %u\n", sfsi->i_blocks);
      printf("flags = 0x%08X\n", sfsi->i_flags);
      printf("version = %u\n", sfsi->i_version);
      printf("file acl = %u\n", sfsi->i_file_acl);
      printf("dir acl = %u\n", sfsi->i_dir_acl);
      printf("fragaddr = %u\n", sfsi->i_faddr);
      printf("fragnum = %u\n", sfsi->osd2.linux2.l_i_frag);
      printf("fragsize = %u\n", sfsi->osd2.linux2.l_i_fsize);
      printf("icopies = %u\n", sfsi->i_icopies);
      printf("bcopies = %u\n", sfsi->i_bcopies);

      printf("inodes =");
      for(j=0; j<STEGFS_MAX_INO_COPIES; j++) {
	printf(" %u", sfsi->i_inode[j]);
      }
      printf("\n");

      printf("blocks:\n");
      for(j=0; j<STEGFS_MAX_BLOCK_COPIES; j++) {
	printf("%lu =", j);
	for(k=0; k<EXT2_N_BLOCKS; k++) {
	  printf(" %u", sfsi->i_block[j*EXT2_N_BLOCKS+k]);
	}
	printf("\n");
      }
    }
    else if(type == 'd') {
      for(j=0; j<1024;) {

	dent = (struct ext2_dir_entry_2 *)(data+j);

	printf("ino: %u   reclen: %u   namelen: %u   filetype: %u\n",
	       dent->inode, dent->rec_len, dent->name_len,
	       dent->file_type);
	printf("name: %s\n",dent->name);
	j+=dent->rec_len;
      }


    }
    else if(type == 'n') {
      data32 = (unsigned int *)data;
      for(j=0; j<128; j++) {
	printf("%u  ", data32[j]);
	if(!((j+1)%8))
	  printf("\n");
      }
    }
  }

  free(key);
  /*  fclose(fs); */
  return 0;
}
